#!/usr/bin/python
import sys
import pywbem
import getpass
 
NS = 'netapp/cimv2'
myhostp = "https://%s:5989" % sys.argv[1]

operation_type = sys.argv[4] 

client = pywbem.WBEMConnection(myhostp, (sys.argv[2],sys.argv[3]), NS)

#opreation 1 is for information about the FA_System used in discovery
if operation_type == '1':

  data=client.InvokeMethod('GetProperties',pywbem.CIMInstanceName('FA_System', NS),)
  if data[0] == 0:
        print "FA_System:"
        for (slug, title) in data[1]['FA_System'].items():
                 print slug+":", title
  else:
   	print "ERROR CODE:",hex(data[1]['FA_Exception']['FAErrorCode'])
   	print "ERROR MSG:",data[1]['FA_Exception']['FAErrorMessage']       

  data=client.InvokeMethod('ListPhysicalDevices',pywbem.CIMInstanceName('FA_System', NS),)
  if data[0] == 0:
        print "\nFA_PhysicalDevice:"
        for (slug, title) in data[1]['FA_PhysicalDevice'][0].items():
                if slug == 'HBTL':
			  try:
				print slug+":", title[0]
			  except:
				print  title
		else:
			print slug+":", title
  else:
        print "TotalSize:"
	print "NAAIdentifier:"
	print "AllocatedSize:"
	print "DeviceState: 0"
	print "HBTL:"

elif operation_type == '2':
  # this loops thorugh all the prepared CacheSpaces that are available
  data=client.InvokeMethod('ListCacheSpaces',pywbem.CIMInstanceName('FA_System', NS),)
  if data[0] == 0:
    for (i, item) in enumerate(data[1]['FA_CacheSpace']):
          print "FA_CacheSpace:"+str(i)
          for (slug, title) in item.items():
                      print slug+":", title
  else:
        print "ERROR CODE:",hex(data[1]['FA_Exception']['FAErrorCode'])
        print "ERROR MSG:",data[1]['FA_Exception']['FAErrorMessage']
  
#operation 3 invokes the initialize cache Function
elif operation_type == '3':
  data=client.InvokeMethod('InitializeCache',pywbem.CIMInstanceName('FA_System', NS),SegmentSize=pywbem.Uint64(0))
  if data[0] == 0:
	print "";
  else:
        print "ERROR CODE:",hex(data[1]['FA_Exception']['FAErrorCode'])
        print "ERROR MSG:",data[1]['FA_Exception']['FAErrorMessage']

#operation 4 invokes the Allocate cache Function
elif operation_type == '4':
  try:
  	identifier=sys.argv[6]
  except IndexError:
        identifier = ""
  
  data=client.InvokeMethod('AllocateCacheSpace',pywbem.CIMInstanceName('FA_System', NS),CacheSpaceID=identifier,NumSegments=pywbem.Uint64(sys.argv[5]))
  if data[0] == 0:
	print data[1]['CacheSpaceID']
  else:
        print "ERROR CODE:",hex(data[1]['FA_Exception']['FAErrorCode'])
        print "ERROR MSG:",data[1]['FA_Exception']['FAErrorMessage']

#operation 5 invokes the Free cache Function	
elif operation_type == '5':
  data=client.InvokeMethod('FreeCacheSpace',pywbem.CIMInstanceName('FA_System', NS),CacheSpaceID=sys.argv[5])
  if data[0] == 0:
	print "";
  else:
        print "ERROR CODE:",hex(data[1]['FA_Exception']['FAErrorCode'])
        print "ERROR MSG:",data[1]['FA_Exception']['FAErrorMessage']

#operation 6 invokes the Get Available Segments Function
elif operation_type == '6':
  data=client.InvokeMethod('GetProperties',pywbem.CIMInstanceName('FA_System', NS),)
  if data[0] == 0:
	print data[1]['FA_System']['NumFreeSegments']
  else:
        print "ERROR CODE:",hex(data[1]['FA_Exception']['FAErrorCode'])
        print "ERROR MSG:",data[1]['FA_Exception']['FAErrorMessage']

#operation 7 invokes the Get Largest Allocatable Cache Space Function
elif operation_type == '7':
  data=client.InvokeMethod('GetProperties',pywbem.CIMInstanceName('FA_System', NS),)
  if data[0] == 0:
	print data[1]['FA_System']['NumMaxAllocatableSegments']
  else:
        print "ERROR CODE:",hex(data[1]['FA_Exception']['FAErrorCode'])
        print "ERROR MSG:",data[1]['FA_Exception']['FAErrorMessage']

#operation 8 invokes the List of Physical Devices
elif operation_type == '8':
  #this returns the details of the phyical device
  data=client.InvokeMethod('ListPhysicalDevices',pywbem.CIMInstanceName('FA_System', NS),)
  if data[0] == 0:
	print "\nFA_PhysicalDevice:"
  	for (slug, title) in data[1]['FA_PhysicalDevice'][0].items():
     		 print slug+":", title
  else:
        print "ERROR CODE:",hex(data[1]['FA_Exception']['FAErrorCode'])
        print "ERROR MSG:",data[1]['FA_Exception']['FAErrorMessage'] 
