<?php
/**
 *  Flash Accel Management Console (FMC)
 *  Copyright (C) 2013, NetApp, Inc.
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License along
 *  with this program; if not, write to the Free Software Foundation, Inc.,
 *  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 *
 *  Javascript
 *
 *    Farbtastic - Copyright (c) 2010 Matt Farina
 *
 *    jQuery - Copyright (c) 2010 John Resig
 * 
 *    jQuery BBQ - Copyright (c) 2010 "Cowboy" Ben Alman
 *  
 *    jQuery Cookie - Copyright (c) 2006 Klaus Hartl
 *  
 *    jQuery Form - Copyright (c) 2010 Mike Alsup
 *  
 *    jQuery Once - Copyright (c) 2009 Konstantin K\ufffdfer
 *
 *    jQuery UI - Copyright (c) 2010 by the original authors
 *      (http://jqueryui.com/about)
 *
 *    Sizzle.js - Copyright (c) 2010 The Dojo Foundation (http://sizzlejs.com/)
 *
 *  PHP
 *
 *    ArchiveTar - Copyright (c) 1997 - 2008 Vincent Blavet
 */
  
/**
 * Implements hook_drush_command().
 */
function famc_drush_drush_command() {
  $items = array();

  $items['famc-cron-path'] = array(
    'aliases' => array('famccp'),
    'callback' => 'famc_drush_cron_path',
    'description' => 'Get the cron path.',
    'arguments' => array(
      'site_url' => 'The site URL, e.g. 10.137.187.22 or 10.137.187.22/famc',
    ),
    'options' => array(),
    'examples' => array(
      'drush famccp' => 'Will show the cron path as something like http://your-site.com/cron?cron_key=zXjhhjhhnnasbaas.',
    ),
  );

  return $items;
}

/**
 * Drush callback famc_drush_cron_path
 */
function famc_drush_cron_path($site_url = '') {
  if (empty($site_url)) {
    return drush_set_error('FAMC_DRUSH_CRON_PATH_FAILURE', dt('Unable to get the path with a blank URL.'));
  }
  $cron_path = url($site_url . '/cron.php', array('external' => TRUE, 'query' => array('cron_key' => variable_get('cron_key', 'drupal'))));
  drush_print($cron_path);
}
