<?php
/**
 *  Flash Accel Management Console (FMC)
 *  Copyright (C) 2013, NetApp, Inc.
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License along
 *  with this program; if not, write to the Free Software Foundation, Inc.,
 *  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 *
 *  Javascript
 *
 *    Farbtastic - Copyright (c) 2010 Matt Farina
 *
 *    jQuery - Copyright (c) 2010 John Resig
 * 
 *    jQuery BBQ - Copyright (c) 2010 "Cowboy" Ben Alman
 *  
 *    jQuery Cookie - Copyright (c) 2006 Klaus Hartl
 *  
 *    jQuery Form - Copyright (c) 2010 Mike Alsup
 *  
 *    jQuery Once - Copyright (c) 2009 Konstantin K\ufffdfer
 *
 *    jQuery UI - Copyright (c) 2010 by the original authors
 *      (http://jqueryui.com/about)
 *
 *    Sizzle.js - Copyright (c) 2010 The Dojo Foundation (http://sizzlejs.com/)
 *
 *  PHP
 *
 *    ArchiveTar - Copyright (c) 1997 - 2008 Vincent Blavet
 */

class clsWSSEAuth {
  private $Username;
  private $Password;
  function __construct($username, $password) {
    $this->Username=$username;
    $this->Password=$password;
  }
}

class clsWSSEToken {
  private $UsernameToken;
  function __construct ($innerVal){
    $this->UsernameToken = $innerVal;
  }
}

/**
 * Construct the SOAP client request
 */
function mercury_management_wsdl_construct($hostname, $username, $password, $port) {
  
  //Check with your provider which security name-space they are using.
  $strWSSENS = "http://docs.oasis-open.org/wss/2004/01/oasis-200401-wss-wssecurity-secext-1.0.xsd";
  
  $objSoapVarUser = new SoapVar($username, XSD_STRING, NULL, $strWSSENS, NULL, $strWSSENS);
  $objSoapVarPass = new SoapVar($password, XSD_STRING, NULL, $strWSSENS, NULL, $strWSSENS);
  
  $objWSSEAuth = new clsWSSEAuth($objSoapVarUser, $objSoapVarPass);
  $objSoapVarWSSEAuth = new SoapVar($objWSSEAuth, SOAP_ENC_OBJECT, NULL, $strWSSENS, 'UsernameToken', $strWSSENS);
  $objWSSEToken = new clsWSSEToken($objSoapVarWSSEAuth);
  $objSoapVarWSSEToken = new SoapVar($objWSSEToken, SOAP_ENC_OBJECT, NULL, $strWSSENS, 'UsernameToken', $strWSSENS);
  $objSoapVarHeaderVal=new SoapVar($objSoapVarWSSEToken, SOAP_ENC_OBJECT, NULL, $strWSSENS, 'Security', $strWSSENS);
  
  $objSoapVarWSSEHeader = new SoapHeader($strWSSENS, 'Security', $objSoapVarHeaderVal,true);
  $wsdl = 'https://' . $hostname . ':' . $port . '/hgservice?wsdl';
  try {
    $client = @new SoapClient($wsdl,
			      array('exceptions' => true,
				    'soap_version' => SOAP_1_1,
				    'encoding' => 'ISO-8859-1',
				    'features' => SOAP_SINGLE_ELEMENT_ARRAYS,
				    'cache_wsdl' => WSDL_CACHE_BOTH));
    $client->__setSoapHeaders(array($objSoapVarWSSEHeader));
    return $client;  
  }
  catch(SoapFault $exp) {
    return false;
  } 
}

/**
 * Issue the web service call to the VM
 */
function mercury_management_consume_webservice($client, $param, $method) {
  if (!$client) {
    return array('error' => '');
  }
  try {
    $name_space = "http://www.NetApp.com/HgService/v_1.0";
    $Response = $client->$method($param);
    $output['response'] = $Response;
    $output['response_status'] = 'success';
  }
  catch (SoapFault $exp) {
    $error = $exp->getMessage();
    $wderror = $method . 'Error';
    $output['error'] = $wderror;
    $output['response_status'] = 'error';
  }
  return $output;
}
