/*
 *  Flash Accel Management Console (FMC)
 *  Copyright (C) 2013, NetApp, Inc.
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License along
 *  with this program; if not, write to the Free Software Foundation, Inc.,
 *  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 *
 *  Javascript
 *
 *    Farbtastic - Copyright (c) 2010 Matt Farina
 *
 *    jQuery - Copyright (c) 2010 John Resig
 * 
 *    jQuery BBQ - Copyright (c) 2010 "Cowboy" Ben Alman
 *  
 *    jQuery Cookie - Copyright (c) 2006 Klaus Hartl
 *  
 *    jQuery Form - Copyright (c) 2010 Mike Alsup
 *  
 *    jQuery Once - Copyright (c) 2009 Konstantin K\ufffdfer
 *
 *    jQuery UI - Copyright (c) 2010 by the original authors
 *      (http://jqueryui.com/about)
 *
 *    Sizzle.js - Copyright (c) 2010 The Dojo Foundation (http://sizzlejs.com/)
 *
 *  PHP
 *
 *    ArchiveTar - Copyright (c) 1997 - 2008 Vincent Blavet
 */

var timer;
var uninstall_steps = new Array('start', 'createBatch', 'copyBat', 'uninstall');
var install_steps = new Array('start', 'createBatch', 'copyMSI', 'copyBAT', 'install');
var mercuryManagementUinstallIdx = 0;
var mercuryManagementInstallIdx = 0;
var vm_nids = new Array();
var host_nids = new Array();

var upgrade_steps = new Array('start', 'createBatch', 'copyMSI', 'copyBAT', 'install');
var mercuryManagementUpgradeIdx = 0;

var host_uninstall_steps = new Array('start', 'maintain', 'maintanace', 'uninstall');
var host_install_steps = new Array('start', 'maintain', 'maintanace', 'copyZip', 'install');
var hostMercuryManagementUinstallIdx = 0;
var hostMercuryManagementInstallIdx = 0;

var host_upgrade_steps = new Array('start', 'maintain', 'maintanace', 'copyIZip', 'update', 'postupgrade');
var hostMercuryManagementUpgradeIdx = 0;

var cache_initialize_steps = new Array('start', 'initialize');
var cacheInitializeIdx = 0;
var bulkVMAgentIDx = 0;
var bulkHostAgentIDx = 0;

var bulkInstallVMIdx = 0,
	bulkUninstallVMIdx = 0,
	bulkInstallHostIdx = 0,
	bulkUninstallHostIdx = 0;

jQuery(document).ready(function() {
	//	Function to initialize host ssd cache
	jQuery('.host-initialize.mercury-button').live('click', function() {
		var vm_id = jQuery(this).attr('id').split('-')[1];
		jQuery('.processing').show();
		jQuery('#vm-status-message').append('<div class="res-message red">Please do not close the browser window until the process completes.</div>');
		jQuery('#vm-status-message').append('<div class="res-message">Initializing Flash Device Cache...</div>');
		jQuery('.modal-header a.close').hide();
		mercuryManagementInitializeCache(vm_id);
	});
	
	//	Functions for install and uninstall the mercury driver on VM
	jQuery('.uninstall.mercury-button').live('click', function() {
		if (jQuery(this).attr('id').trim() == '') {
			jQuery('#vm-status-message').append('<div class="res-message">No VM selected.</div>');
		} else {
			vm_nids.push(jQuery(this).attr('id').split('-')[1]);
			jQuery('.processing').show();
			jQuery('#vm-status-message').append('<div class="res-message red">Please do not close the browser window until the process completes.</div>');
			jQuery('.modal-header a.close').hide();
			mercuryManagementUinstall();
		}
	});
	
	jQuery('.install.mercury-button').live('click', function() {
		if (jQuery(this).attr('id').trim() == '') {
			jQuery('#vm-status-message').append('<div class="res-message">No VM selected.</div>');
		} else {
			vm_nids.push(jQuery(this).attr('id').split('-')[1]);
			jQuery('.processing').show();
			jQuery('#vm-status-message').append('<div class="res-message red">Please do not close the browser window until the process completes.</div>');
			jQuery('.modal-header a.close').hide();
			mercuryManagementInstall();
		}
	});
	jQuery('.upgrade.mercury-button').live('click', function() {
		if (jQuery(this).attr('id').trim() == '') {
			jQuery('#vm-status-message').append('<div class="res-message">No VM selected.</div>');
		} else {
			var vm_id = jQuery(this).attr('id').split('-')[1];
			//vm_nids.push(jQuery(this).attr('id').split('-')[1]);
			jQuery('.processing').show();
			jQuery('#vm-status-message').append('<div class="res-message red">Please do not close the browser window until the process completes.</div>');
			jQuery('.modal-header a.close').hide();
			mercuryManagementUpgrade(vm_id);
		}
	});
	
//	jQuery('.upgrade.mercury-button').live('click', function() {
//		var vm_id = jQuery(this).attr('id').split('-')[1];
//		jQuery('.processing').show();
//		jQuery('#vm-status-message').append('<div class="res-message red">Please do not close the browser window until the process is completed. It is recommended to reboot your VM to avoid complications that may arise.</div>');
//		jQuery('#vm-status-message').append('<div class="res-message">Upgrading Flash Accel Guest OS Agent...</div>');
//		jQuery('.modal-header a.close').hide();
//		jQuery('.popup-setting-page .close-popup').hide();
//		mercuryManagementUpgrade(vm_id);
//	});
	
	//	Functions for install and uninstall the hypervisor bundle on Host
	jQuery('.host-uninstall.mercury-button').live('click', function() {
		if (jQuery(this).attr('id').trim() == '') {
			jQuery('#vm-status-message').append('<div class="res-message">No Host selected.</div>');
		} else {
			host_nids.push(jQuery(this).attr('id').split('-')[1]);
			jQuery('.processing').show();
			jQuery('#vm-status-message').append('<div class="res-message red">Please do not close the browser window until the process completes. It is recommended that the host is rebooted for ensuring correct operation and the changes to take effect.</div>');
			jQuery('.modal-header a.close').hide();
			hypervisorBundleUinstall();
		}
	});
	
	jQuery('.host-install.mercury-button').live('click', function() {
		if (jQuery(this).attr('id').trim() == '') {
			jQuery('#vm-status-message').append('<div class="res-message">No Host selected.</div>');
		} else {
			host_nids.push(jQuery(this).attr('id').split('-')[1]);
			jQuery('.processing').show();
			jQuery('#vm-status-message').append('<div class="res-message red">Please do not close the browser window until the process completes.</div>');
			jQuery('.modal-header a.close').hide();
			hypervisorBundleInstall();
		}
	});
	
	jQuery('.host-upgrade.mercury-button').live('click', function() {
		var vm_id = jQuery(this).attr('id').split('-')[1];
		jQuery('.processing').show();
		jQuery('#vm-status-message').append('<div class="res-message red">Please do not close the browser window until the process completes.</div>');
		jQuery('#vm-status-message').append('<div class="res-message">Upgrading Flash Accel Host Agent...</div>');
		jQuery('.modal-header a.close').hide();
		jQuery('.popup-setting-page .close-popup').hide();
		hypervisorBundleUpgrade(vm_id);
	});
	
	jQuery('.bulk-host-uninstall.mercury-button').live('click', function() {
		if (jQuery(this).attr('id').trim() == '') {
			window.location = 'mercury/operation/host/uninstall';
		} else {
			var vm_ids = jQuery(this).attr('id').split(',');
			for (var i = 0; i < vm_ids.length; i++) {
				if (vm_ids[i] != '') {
					host_nids.push(vm_ids[i]);
				}
			}
			
			jQuery('#vm-status-message').append('<div class="res-message red">Please do not close the browser window until the process completes. It is recommended that the host is rebooted for ensuring correct operation and the changes to take effect.</div>');
			jQuery('.processing').show();
			jQuery('.modal-header a.close').hide();
			hypervisorBundleUinstall();
		}
	});
	jQuery('.bulk-host-install.mercury-button').live('click', function() {
		if (jQuery(this).attr('id').trim() == '') {
			window.location = 'mercury/operation/host/install';
		} else {
			var vm_ids = jQuery(this).attr('id').split(',');
			for (var i = 0; i < vm_ids.length; i++) {
				if (vm_ids[i] != '') {
					host_nids.push(vm_ids[i]);
				}
			}
			jQuery('#vm-status-message').append('<div class="res-message red">Please do not close the browser window until the process completes.</div>');
			jQuery('.processing').show();
			jQuery('.modal-header a.close').hide();
			hypervisorBundleInstall();
		}
	});
	jQuery('.bulk-vm-uninstall.mercury-button').live('click', function() {
		if (jQuery(this).attr('id').trim() == '') {
			window.location = 'mercury/operation/vm/uninstall';
		} else {
			var vm_ids = jQuery(this).attr('id').split(',');
			for (var i = 0; i < vm_ids.length; i++) {
				if (vm_ids[i] != '') {
					vm_nids.push(vm_ids[i]);
				}
			}
			
			jQuery('img.custom-close').remove();
			jQuery('#vm-status-message').append('<div class="res-message red">Please do not close the browser window until the process completes.</div>');
			jQuery('.processing').show();
			jQuery('.modal-header a.close').hide();
			mercuryManagementUinstall();
		}
	});
	
	jQuery('.bulk-vm-install.mercury-button').live('click', function() {
		if (jQuery(this).attr('id').trim() == '') {
			window.location = 'mercury/operation/vm/install';
		} else {
			var vm_ids = jQuery(this).attr('id').split(',');
			for (var i = 0; i < vm_ids.length; i++) {
				if (vm_ids[i] != '') {
					vm_nids.push(vm_ids[i]);
				}
			}
			jQuery('img.custom-close').remove();
			jQuery('#vm-status-message').append('<div class="res-message red">Please do not close the browser window until the process completes.</div>');
			jQuery('.processing').show();
			jQuery('.modal-header a.close').hide();
			mercuryManagementInstall();
		}
	});
	
	jQuery('img.custom-close').live('click', function() {
		jQuery('#modalContent').remove();
    jQuery('#modalBackdrop').remove();
		location.reload();
	});
	
});

function mercuryManagementUinstall() {
	var link = ''
	if (jQuery('input.vm-reboot-check').is(':checked')) {
		link = Drupal.settings.basePath + "vm/mercury/uninstall/" + vm_nids[bulkVMAgentIDx] + "?step=" + uninstall_steps[mercuryManagementUinstallIdx] + "&reboot=yes";
	} else {
		link = Drupal.settings.basePath + "vm/mercury/uninstall/" + vm_nids[bulkVMAgentIDx] + "?step=" + uninstall_steps[mercuryManagementUinstallIdx] + "&reboot=no";
	}
	
	jQuery.ajax({
		url: link,	
		type: "GET",	
		cache: false,
		success: function (html) {
			var htmlSplit = html.split('--');
			if (htmlSplit[0] == 'uninstall') {
				jQuery('#vm-status-message').append('<div class="res-message red">Uninstallation failed because the VM Agent is not installed in the Virtual Machine "' + htmlSplit[1] + '".</div><div class="blank-div"></div>');
				mercuryManagementUinstallIdx = uninstall_steps.length;
			} else if (htmlSplit[0] == 'error') {
				jQuery('#vm-status-message').append('<div class="res-message red">Uninstallation failed because there is an error communicating with the VM "' + htmlSplit[1] + '".</div><div class="blank-div"></div>');
				mercuryManagementUinstallIdx = uninstall_steps.length;
			} else if (html == 'uBAT_exists') {
				jQuery('#vm-status-message').append('<div class="res-message">Uninstall batch file exists in the guest.</div>');
				mercuryManagementUinstallIdx = mercuryManagementUinstallIdx + 2;
			} else if (htmlSplit[0] == 'cache_exists') {
				jQuery('#vm-status-message').append('<div class="res-message red">Uninstall failed because there is a cache space allocated to the Virtual Machine "' + htmlSplit[1] + '". Unallocate it first to Uninstall Flash Accel Guest OS Agent.</div><div class="blank-div"></div>');
				mercuryManagementUinstallIdx = uninstall_steps.length;
			} else if (htmlSplit[0] == 'admin_enabled') {
				jQuery('#vm-status-message').append('<div class="res-message red">Uninstall failed because cache is enabled on Virtual Machine "' + htmlSplit[1] + '". Disable it first to Uninstall Flash Accel Guest OS Agent.</div><div class="blank-div"></div>');
				mercuryManagementUinstallIdx = uninstall_steps.length;
			} else if (htmlSplit[0] == 'vmrunBatError') {
        jQuery('#vm-status-message').append('<div class="res-message red">Uninstall failed. Could not execute uninstallation batch file on the Virtual Machine "' + htmlSplit[1] + '".</div><div class="blank-div"></div>');
        mercuryManagementInstallIdx = uninstall_steps.length;
      } else if (htmlSplit[0] == 'rebootRequired') {
        jQuery('#vm-status-message').append('<div class="res-message red">Uninstall failed. The Virtual machine "' + htmlSplit[1] + '" needs to be rebooted before uninstall can be done. </div><div class="blank-div"></div>');
        mercuryManagementInstallIdx = uninstall_steps.length;
      } else if (htmlSplit[0] == 'copyFailed') {
        jQuery('#vm-status-message').append('<div class="res-message red">Uninstall failed. Could not copy uninstallation batch file to the Virtual Machine "' + htmlSplit[1] + '".</div><div class="blank-div"></div>'); 
        mercuryManagementInstallIdx = uninstall_steps.length;
      }else {
				jQuery('#vm-status-message').append(html);
				mercuryManagementUinstallIdx++;
			}
			if (mercuryManagementUinstallIdx < uninstall_steps.length) {
				mercuryManagementUinstall();
			} else {
				bulkVMAgentIDx++;
				mercuryManagementUinstallIdx = 0;
				if (bulkVMAgentIDx < vm_nids.length) {
					if (jQuery('img.custom-close').length) {
						jQuery('img.custom-close').remove();
					}
					mercuryManagementUinstall();
				} else {
					vm_nids = new Array();
					bulkVMAgentIDx = 0;
					jQuery('.processing').hide();
					jQuery('#modalContent .modal-header').append('<img class="custom-close" title="Close popup" alt="Close popup" src="/sites/all/modules/contrib/ctools/images/icon-close-window.png">');
					
					var suc_str = '<div class="messages status">The uninstall has completed. Please close the popup and refresh to view the changes.</div>';
					jQuery('#vm-status-message').prepend(suc_str);
				}
			}
		}
	});
}

function mercuryManagementInstall() {
	var link = ''
	if (jQuery('input.vm-reboot-check').is(':checked')) {
		link = "/vm/mercury/install/" + vm_nids[bulkVMAgentIDx] + "?step=" + install_steps[mercuryManagementInstallIdx] + "&reboot=yes";
	} else {
		link = "/vm/mercury/install/" + vm_nids[bulkVMAgentIDx] + "?step=" + install_steps[mercuryManagementInstallIdx] + "&reboot=no";
	}
	jQuery.ajax({
		url: link,	
		type: "GET",		
		cache: false,
		success: function (html) {
			var htmlSplit = html.split('--');
			if (htmlSplit[0] == 'install') {
				jQuery('#vm-status-message').append('<div class="res-message red">Installation failed because the VM Agent is already installed in the Virtual Machine "' + htmlSplit[1] + '".</div><div class="blank-div"></div>');
				mercuryManagementInstallIdx = install_steps.length;
			} else if (htmlSplit[0] == 'Invalid OS') {
				jQuery('#vm-status-message').append('<div class="res-message red">Installation failed because the guest OS in the Virtual Machine "' + htmlSplit[1] + '" is not Windows Server 2008 R2.</div><div class="blank-div"></div>');
				mercuryManagementInstallIdx = install_steps.length;
			} else if (htmlSplit[0] == 'error') {
				jQuery('#vm-status-message').append('<div class="res-message red">Installation failed because there is an error communicating with the Virtual Machine "' + htmlSplit[1] + '".</div><div class="blank-div"></div>');
				mercuryManagementInstallIdx = install_steps.length;
			} else if (htmlSplit[0] == 'vmrunBatError') {
        jQuery('#vm-status-message').append('<div class="res-message red">Installation failed. Could not execute installation batch file on the Virtual Machine "' + htmlSplit[1] + '".</div><div class="blank-div"></div>');
        mercuryManagementInstallIdx = install_steps.length;
      } else if (htmlSplit[0] == 'rebootRequired') {
        jQuery('#vm-status-message').append('<div class="res-message red">Installation failed. The Virtual machine "' + htmlSplit[1] + '" needs to be rebooted install can be done. </div><div class="blank-div"></div>');
        mercuryManagementInstallIdx = install_steps.length;
      } else if (htmlSplit[0] == 'copyFailed') {
        jQuery('#vm-status-message').append('<div class="res-message red">Uninstall failed. Could not copy installation batch file to the Virtual Machine "' + htmlSplit[1] + '".</div><div class="blank-div"></div>');
        mercuryManagementInstallIdx = install_steps.length;
      }else {
				jQuery('#vm-status-message').append(html);
				mercuryManagementInstallIdx++;
			}
			if (mercuryManagementInstallIdx < install_steps.length) {
				mercuryManagementInstall();
			} else {
				bulkVMAgentIDx++;
				mercuryManagementInstallIdx = 0;
				if (bulkVMAgentIDx < vm_nids.length) {
					if (jQuery('img.custom-close').length) {
						jQuery('img.custom-close').remove();
					}
					mercuryManagementInstall();
				} else {
					vm_nids = new Array();
					bulkVMAgentIDx = 0;
					jQuery('.processing').hide();
					jQuery('#modalContent .modal-header').append('<img class="custom-close" title="Close popup" alt="Close popup" src="/sites/all/modules/contrib/ctools/images/icon-close-window.png">');
					
					var suc_str = '<div class="messages status">The installation has completed. Please close the popup and refresh to view the changes.</div>';
					jQuery('#vm-status-message').prepend(suc_str);
				}
			}
		}
	});
}

function mercuryManagementUpgrade(vm_id){
var link = ''
	if (jQuery('input.upgrade-vm-reboot-check').is(':checked')) {
		link = "/vm/mercury/upgrade/" + vm_id + "?step=" + upgrade_steps[mercuryManagementUpgradeIdx] + "&reboot=yes";
	} else {
		link = "/vm/mercury/upgrade/" + vm_id + "?step=" + upgrade_steps[mercuryManagementUpgradeIdx] + "&reboot=no";
	}
	jQuery.ajax({
		url: link,	
		type: "GET",		
		cache: false,
		success: function (html) {
			var htmlSplit = html.split('--');
			if (htmlSplit[0] == 'install') {
				jQuery('#vm-status-message').append('<div class="res-message red">Upgrade failed because the VM Agent is not installed in the Virtual Machine "' + htmlSplit[1] + '".</div><div class="blank-div"></div>');
				mercuryManagementUpgradeIdx = upgrade_steps.length;
			} else if (htmlSplit[0] == 'Invalid OS') {
				jQuery('#vm-status-message').append('<div class="res-message red">Upgrade failed because the guest OS in the Virtual Machine "' + htmlSplit[1] + '" is not Windows Server 2008 R2.</div><div class="blank-div"></div>');
				mercuryManagementUpgradeIdx = upgrade_steps.length;
			} else if (htmlSplit[0] == 'password') {
				jQuery('#vm-status-message').append('<div class="res-message red">Upgrade failed because the username and password are not set for the Virtual Machine "' + htmlSplit[1] + '".</div><div class="blank-div"></div>');
				mercuryManagementUpgradeIdx = upgrade_steps.length;
			} else if (htmlSplit[0] == 'vmrunBatError') {
        jQuery('#vm-status-message').append('<div class="res-message red">Upgrade failed. Could not execute upgrade batch file on the Virtual Machine "' + htmlSplit[1] + '".</div><div class="blank-div"></div>');
        mercuryManagementUpgradeIdx = upgrade_steps.length;
      } else if (htmlSplit[0] == 'rebootRequired') {
        jQuery('#vm-status-message').append('<div class="res-message red">Upgrade failed. The Virtual machine "' + htmlSplit[1] + '" needs to be rebooted before upgrade. </div><div class="blank-div"></div>');
        mercuryManagementUpgradeIdx = upgrade_steps.length;
      } else if (htmlSplit[0] == 'copyFailed') {
        jQuery('#vm-status-message').append('<div class="res-message red">Upgrade failed. Could not copy upgrade batch file to the Virtual Machine "' + htmlSplit[1] + '".</div><div class="blank-div"></div>');
        mercuryManagementUpgradeIdx = upgrade_steps.length;
      } else {
				jQuery('#vm-status-message').append(html);
				mercuryManagementUpgradeIdx++;
			}
			if (mercuryManagementUpgradeIdx < upgrade_steps.length) {
				mercuryManagementUpgrade(vm_id);
			} else {
				jQuery('.processing').hide();
				jQuery('#modalContent .modal-header').append('<img class="custom-close" title="Close popup" alt="Close popup" src="/sites/all/modules/contrib/ctools/images/icon-close-window.png">');
				
				var suc_str = '<div class="messages status">The upgrade has completed. Please close the popup and refresh to view the changes.</div>';
				jQuery('#vm-status-message').prepend(suc_str);
			}
		}
	});
}

function hypervisorBundleUinstall() {
	jQuery.ajax({
		url: "/host/hypervisor-bundle/uninstall/" + host_nids[bulkHostAgentIDx] + "?step=" + host_uninstall_steps[hostMercuryManagementUinstallIdx],	
		type: "GET",	
		cache: false,
		success: function (html) {
			var htmlSplit = html.split('--');
			if (htmlSplit[0] == 'Exit') {
				jQuery('#vm-status-message').append('<div class="res-message red">The host "' + htmlSplit[1] + '" is not in maintenance mode. Please put the host in maintenance mode manually and start the process again.</div><div class="blank-div"></div>');
				hostMercuryManagementUinstallIdx = host_uninstall_steps.length;
			} else if (htmlSplit[0] == 'uninstall') {
				jQuery('#vm-status-message').append('<div class="res-message red">Uninstallation failed because the host agent is not installed on the Host "' + htmlSplit[1] + '".</div><div class="blank-div"></div>');
				hostMercuryManagementUinstallIdx = host_uninstall_steps.length;
			} else if (htmlSplit[0] == 'error') {
				jQuery('#vm-status-message').append('<div class="res-message red">Uninstallation failed because there is an error communicating with the Host "' + htmlSplit[1] + '".</div><div class="blank-div"></div>');
				hostMercuryManagementUinstallIdx = host_uninstall_steps.length;
			} else {
				jQuery('#vm-status-message').append(html);
				hostMercuryManagementUinstallIdx++;
			}
			
			if (hostMercuryManagementUinstallIdx < host_uninstall_steps.length) {
				hypervisorBundleUinstall();
			} else {
				bulkHostAgentIDx++;
				hostMercuryManagementUinstallIdx = 0;
				if (bulkHostAgentIDx < host_nids.length) {
					if (jQuery('img.custom-close').length) {
						jQuery('img.custom-close').remove();
					}
					hypervisorBundleUinstall();
				} else {
					host_nids = new Array();
					bulkHostAgentIDx = 0;
					jQuery('.processing').hide();
					jQuery('#modalContent .modal-header').append('<img class="custom-close" title="Close popup" alt="Close popup" src="/sites/all/modules/contrib/ctools/images/icon-close-window.png">');
					
					var suc_str = '<div class="messages status">The uninstall has completed. Please close the popup to view the changes.</div>';
					jQuery('#vm-status-message').prepend(suc_str);
				}
			}
		}
	});
}

function hypervisorBundleInstall() {
	jQuery.ajax({
		url: "/host/hypervisor-bundle/install/" + host_nids[bulkHostAgentIDx] + "?step=" + host_install_steps[hostMercuryManagementInstallIdx],	
		type: "GET",	
		cache: false,
		success: function (html) {
			var htmlSplit = html.split('--');
			if (htmlSplit[0] == 'Exit') {
				jQuery('#vm-status-message').append('<div class="res-message red">The host "' + htmlSplit[1] + '" is not in maintenance mode. Please put the host in maintenance mode manually and start the process again.</div><div class="blank-div"></div>');
				hostMercuryManagementInstallIdx = host_install_steps.length;
			} else if (htmlSplit[0] == 'install') {
				jQuery('#vm-status-message').append('<div class="res-message red">Installation failed because the host agent is already installed in the Host "' + htmlSplit[1] + '".</div><div class="blank-div"></div>');
				hostMercuryManagementInstallIdx = host_install_steps.length;
			} else if (htmlSplit[0] == 'acceptance') {
                jQuery('#vm-status-message').append('<div class="res-message red">Installation failed on "' + htmlSplit[1] + '". Installing the host agent requires that the system be at a PartnerSupported acceptance level or lower.</div><div class="blank-div"></div>');
                hostMercuryManagementInstallIdx = host_install_steps.length;			
			} else if (htmlSplit[0] == 'error') {
                jQuery('#vm-status-message').append('<div class="res-message red">Installation failed on "' + htmlSplit[1] + '".</div><div class="blank-div"></div>');
				hostMercuryManagementInstallIdx = host_install_steps.length;
			} else {
				jQuery('#vm-status-message').append(html);
				hostMercuryManagementInstallIdx++;
			}
			if (hostMercuryManagementInstallIdx < host_install_steps.length) {
				hypervisorBundleInstall();
			} else {
				bulkHostAgentIDx++;
				hostMercuryManagementInstallIdx = 0;
				if (bulkHostAgentIDx < host_nids.length) {
					if (jQuery('img.custom-close').length) {
						jQuery('img.custom-close').remove();
					}
					hypervisorBundleInstall();
				} else {
					host_nids = new Array();
					bulkHostAgentIDx = 0;
					jQuery('.processing').hide();
					jQuery('#modalContent .modal-header').append('<img class="custom-close" title="Close popup" alt="Close popup" src="/sites/all/modules/contrib/ctools/images/icon-close-window.png">');
					
					var suc_str = '<div class="messages status">The host install has completed. Please close the popup to view the changes.</div>';
					jQuery('#vm-status-message').prepend(suc_str);
				}
			}
		}
	});
}

function hypervisorBundleUpgrade(vm_id) {
	jQuery.ajax({
		url: "/host/hypervisor-bundle/upgrade/" + vm_id + "?step=" + host_upgrade_steps[hostMercuryManagementUpgradeIdx],	
		type: "GET",	
		cache: false,
		success: function (html) {
			var htmlSplit = html.split('--');
			if (htmlSplit[0] == 'exit') {
				jQuery('#vm-status-message').append('<div class="res-message red">The host is not in maintenance mode. Please put the host in maintenance mode manually and start the upgrade process again.</div>');
				hostMercuryManagementUpgradeIdx = host_upgrade_steps.length;
			} else if (htmlSplit[0] == 'zip_copy_failure') {
				jQuery('#vm-status-message').append('<div class="res-message red">The upgrade files could not be copied to the host.</div>');
				hostMercuryManagementUpgradeIdx = host_upgrade_steps.length;
			} else if (htmlSplit[0] == 'unchanged') {
				jQuery('#vm-status-message').append('<div class="res-message red">The upgrade failed. Host is unchanged. Please see logs for more details.</div>');			
				hostMercuryManagementUpgradeIdx = host_upgrade_steps.length;
			} else if (htmlSplit[0] == 'unknown') {
				jQuery('#vm-status-message').append('<div class="res-message red">Upgrade failed. Please verify that the host is in a consistent state.</div>');
				hostMercuryManagementUpgradeIdx = host_upgrade_steps.length;
			} else if (htmlSplit[0] == 'uninstalled') {
				jQuery('#vm-status-message').append('<div class="res-message red">Upgrade cannot be done as Flash Accel is not installed on host.</div>');
				hostMercuryManagementUpgradeIdx = host_upgrade_steps.length;
			} else {
				jQuery('#vm-status-message').append(html);
				hostMercuryManagementUpgradeIdx++;
			}
			
			if (hostMercuryManagementUpgradeIdx < host_upgrade_steps.length) {
				hypervisorBundleUpgrade(vm_id);
			} else {
				//hostMercuryManagementUpgradeIdx = 2;
				jQuery('.processing').hide();
				//jQuery('.modal-header a.close').show();
				jQuery('#modalContent .modal-header').append('<img class="custom-close" title="Close popup" alt="Close popup" src="/sites/all/modules/contrib/ctools/images/icon-close-window.png">');
				jQuery('.popup-setting-page .close-popup').show();
				
				var suc_str = '<div class="messages status">The host upgrade completed. Please close the popup to view the changes.</div>';
				jQuery('#vm-status-message').prepend(suc_str);
			}
		}
	});
}

function mercuryManagementInitializeCache(vm_id) {
	jQuery.ajax({
		url: "/host/ssd/initialize/" + vm_id + "?step=" + cache_initialize_steps[cacheInitializeIdx],	
		type: "POST",	
		cache: false,
		success: function (html) {
			jQuery('#vm-status-message').append(html);
			cacheInitializeIdx++;
			if (cacheInitializeIdx < cache_initialize_steps.length) {
				mercuryManagementInitializeCache(vm_id);
			} else {
				jQuery('.processing').hide();
				jQuery('#modalContent .modal-header').append('<img class="custom-close" title="Close popup" alt="Close popup" src="/sites/all/modules/contrib/ctools/images/icon-close-window.png">');
				var suc_str = '<div class="success-message green">Cache initialization has completed. Please close the popup to view the changes.</div>';
				jQuery('#vm-status-message').prepend(suc_str);
			}
		}
	});
}
