<?php
/**
 *  Flash Accel Management Console (FMC)
 *  Copyright (C) 2013, NetApp, Inc.
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License along
 *  with this program; if not, write to the Free Software Foundation, Inc.,
 *  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 *
 *  Javascript
 *
 *    Farbtastic - Copyright (c) 2010 Matt Farina
 *
 *    jQuery - Copyright (c) 2010 John Resig
 * 
 *    jQuery BBQ - Copyright (c) 2010 "Cowboy" Ben Alman
 *  
 *    jQuery Cookie - Copyright (c) 2006 Klaus Hartl
 *  
 *    jQuery Form - Copyright (c) 2010 Mike Alsup
 *  
 *    jQuery Once - Copyright (c) 2009 Konstantin K\ufffdfer
 *
 *    jQuery UI - Copyright (c) 2010 by the original authors
 *      (http://jqueryui.com/about)
 *
 *    Sizzle.js - Copyright (c) 2010 The Dojo Foundation (http://sizzlejs.com/)
 *
 *  PHP
 *
 *    ArchiveTar - Copyright (c) 1997 - 2008 Vincent Blavet
 */

    $bundle_install = field_get_items('node', $node, 'field_bundle_status');
    $segment_size = field_get_items('node', $node, 'field_segment_size');
    $allocated_segment = field_get_items('node', $node, 'field_allocated_segments');
    $total_segment = field_get_items('node', $node, 'field_total_segments');
    $cache_state = field_get_items('node', $node, 'field_cache_state');
    $first_part = number_format(($segment_size[0]['value'] * $allocated_segment[0]['value'])/1073741824, 2);
    $second_part = number_format(($segment_size[0]['value'] * $total_segment[0]['value'])/1073741824, 2);
    $vib_version = field_get_items('node', $node, 'field_vib_version');
    $cib_vid_version = $vib_version[0]['value'];
    $device_name = field_get_items('node', $node, 'field_naa_identifier');
    $device_name = $device_name[0]['value'];
    $vendor=field_get_items('node', $node, 'field_host_vendor');
    $model=field_get_items('node', $node, 'field_host_model');
    $platform_name = $vendor[0]['value'] . "-" . $model[0]['value'] ;
    $software_on_host =field_get_items('node', $node, 'field_software_on_host');
    $cache_device_size = field_get_items('node', $node, 'field_total_size');
    $cache_device_size = number_format($cache_device_size[0]['value']/1073741824, 2);
    $vms = field_get_items('node', $node, 'field_allocated_virtual_machines');
    $vms_value = !empty($vms) ? $vms[0]['value'] : 0;
    //$total_size = field_get_items('node', $node, 'field_total_size');
    //$total_size_value = !empty($total_size) ? $total_size[0]['value'] : 0;
    //$total_size_value = number_format($total_size_value/1073741824, 2, '.', '') . 'GB' ; 
    $total_size_value = mercury_management_largestAvailableCache($node->nid);
    $total_size_value = ($total_size_value * 256) / 1024;
    if ($bundle_install[0]['value'] == "Agent Installed") {
      $status_bundle = "Yes";
    } elseif ($bundle_install[0]['value'] == "Agent Not Installed") {
      $status_bundle = "No";
    } else {
      $strng = '<li>Rediscover</li>';
      $status_bundle = "Host Unavailable";
    }
    $field_device_state = field_get_items('node', $node, 'field_device_state');
    $device_state = !empty($field_device_state[0]['value']) ? $field_device_state[0]['value'] : 0 ;
    
    if($device_state == 1) {
        $device_state = 'Enabled';
    }
    else {
        $device_state = 'Disabled';
    }
    $cache_msg = 'N/A';
    if ($cache_state[0]['value'] == 1) {
      $cache_msg = 'Disabled';
    } else if ($cache_state[0]['value'] == 2){
       $cache_msg = 'Disabled';
    } else if ($cache_state[0]['value'] == 3){
       $cache_msg = 'Enabled';
    } else if ($cache_state[0]['value'] == 4){
      $cache_msg = 'Error';
    }
  
  if (!empty($node->field_naa_identifier)) {
    $device_query = db_select('node', 'node');
    $device_query->leftJoin('field_data_field_serial_no', 'field_data_field_serial_no', 'node.nid = field_data_field_serial_no.entity_id AND field_data_field_serial_no.entity_type = :node AND field_data_field_serial_no.deleted = :deleted', array(':deleted' => 0, ':node' => 'node'));
    $device_query->leftJoin('field_data_field_naa_identifier', 'field_data_field_naa_identifier', 'field_data_field_serial_no.field_serial_no_value = field_data_field_naa_identifier.field_naa_identifier_value AND field_data_field_naa_identifier.entity_type = :node AND field_data_field_naa_identifier.deleted = :deleted', array(':deleted' => 0, ':node' => 'node'));
    $device_query->leftJoin('field_data_field_related_host', 'field_data_field_related_host', 'node.nid = field_data_field_related_host.entity_id AND field_data_field_related_host.entity_type = :node AND field_data_field_related_host.deleted = :deleted', array(':deleted' => 0, ':node' => 'node'));
    $device_query->leftJoin('field_data_field_multipath_plugin', 'field_data_field_multipath_plugin', 'node.nid = field_data_field_multipath_plugin.entity_id AND field_data_field_multipath_plugin.entity_type = :node AND field_data_field_multipath_plugin.deleted = :deleted', array(':node' => 'node', ':deleted' => 0));
    $device_query->fields('node', array('nid', 'title'));
    $device_query->condition('node.status', 1)
        ->condition('node.type', 'device')
        ->condition('field_data_field_related_host.field_related_host_target_id', $node->nid)
        ->condition('field_data_field_serial_no.field_serial_no_value', $node->field_naa_identifier['und'][0]['value'])
        ->condition('field_data_field_multipath_plugin.field_multipath_plugin_value', 'FlashAccel');
    $temp_result = $device_query;
    $device_result = $device_query->execute();
    $device_row_count = $temp_result->countQuery()->execute()->fetchField();
    $device_counter = 1;
    while ($device_row = $device_result->fetch()) {
        $device_node = node_load($device_row->nid);//field_vendor[und][0][value]
        $device_vendor = field_get_items('node', $device_node, 'field_vendor');
        $device_model = field_get_items('node', $device_node, 'field_model');
        $product_vendor = $device_model[0]['value'] . "-" . $device_vendor[0]['value'] ;
        
    }
  }
  
?>
<div class="title-box"> </div>
<div class="node-inner-section node-inner-section-first">
	<div class="node-inner-header"><?php print t('Attributes');?></div>
	<div class="node-inner-container">
		
			<div class="info-odd"><label><?php print t('Platform Name');?>:   <span><?php  print $platform_name ;?></span></label></div>
			<div class="info-even"><label><?php print t('ESX Host');?>:  <span><?php print $software_on_host[0]['value']; ?></span></label></div>
	</div>
</div>
<div class="node-inner-section">
	<div class="node-inner-header"><?php print t('Flash Accel Configuration');?></div>
	<div class="node-inner-container" id="vm-metrics-content">
            
            <div class="info-odd"><div class="row-left"><label><?php print t('Flash Accel Host Agent');?>: <span><?php print $status_bundle; ?></span></label></div> <div class="row-right"><label>Host Agent Version: <span><?php print $cib_vid_version;?></span></label></div><div class="clr"></div></div>
		<div class="info-even"><label><?php print t('Cache State');?>: <span><?php print $cache_msg ; ?></span></label></div>
                <div class="info-odd"><label><?php print t('Cache Allocation Information');?>: <span></span></label></div>
                <div class="info-even"><div class="row-left"><label><?php print t('Cache Size');?>: <span><?php print  $first_part . 'GB / ' . $second_part . 'GB'; ?></span></label></div> <div class="row-right"><label>Largest Allocatable size: <span><?php print $total_size_value . 'GB';  ?> </span></label></div><div class="clr"></div></div>
                <div class="info-odd"><label><?php print t('VMs Used');?>: <span><?php print $vms_value;?></span></label></div>
            
	</div>
</div>

<div class="node-inner-section">
	<div class="node-inner-header"><?php print t('Flash Device');?></div>
	<div class="node-inner-container" id="vm-metrics-content">
            
                <div class="info-odd"><div class="row-left"><label><?php print t('Device Name');?>: <span><?php print $device_name; ?></span></label></div> 
                <div class="row-left"><label>Device Size: <span><?php print $cache_device_size; ?> GB</span></label></div><div class="clr"></div></div>
	</div>
</div>
<!-- 
<div class="node-inner-section" style="border: none;">
	<h3 class="table-title"><?php print t('Host Metrics');?></h3>
	<div class="node-inner-container">
		<div class="view-content">
			
		</div>
		<div class="clr"></div>
	</div>
</div> -->
<div class="node-inner-section" style="border: none;">
	<h3 class="table-title"><?php print t('Virtual Machine Metrics');?></h3>
	<div class="node-inner-container" id="host-vm-metric-content">
		<div class="view-content">
			<?php print render($content['vdisk_metric_per_vm_entity_view_2']); ?>
		</div>
		<div class="clr"></div>
	</div>
</div>
