<?php
/**
 *  Flash Accel Management Console (FMC)
 *  Copyright (C) 2013, NetApp, Inc.
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License along
 *  with this program; if not, write to the Free Software Foundation, Inc.,
 *  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 *
 *  Javascript
 *
 *    Farbtastic - Copyright (c) 2010 Matt Farina
 *
 *    jQuery - Copyright (c) 2010 John Resig
 * 
 *    jQuery BBQ - Copyright (c) 2010 "Cowboy" Ben Alman
 *  
 *    jQuery Cookie - Copyright (c) 2006 Klaus Hartl
 *  
 *    jQuery Form - Copyright (c) 2010 Mike Alsup
 *  
 *    jQuery Once - Copyright (c) 2009 Konstantin K\ufffdfer
 *
 *    jQuery UI - Copyright (c) 2010 by the original authors
 *      (http://jqueryui.com/about)
 *
 *    Sizzle.js - Copyright (c) 2010 The Dojo Foundation (http://sizzlejs.com/)
 *
 *  PHP
 *
 *    ArchiveTar - Copyright (c) 1997 - 2008 Vincent Blavet
 */
?>

<table class="metrics">
  <thead>
    <tr>
      <th>
          <span>
        <?php print t('Disk Number'); ?>
          </span>
      </th>
      <th>
          <span>
        <?php print t('Path'); ?>
          </span>
      </th>
      <th>
          <span>
        <?php print t('Cache State'); ?>
          </span>
      </th>
      <th>
          <span>
        <?php print t('Operational Status'); ?>
          </span>
      </th>
      <th>
          <span>
        <?php print t('Hit Rate %'); ?>
          </span>
      </th>
      <th>
          <span>
        <?php print t('Read / Write Latency (ms)'); ?>
          </span>
      </th>
      <th>
        
      </th>
    </tr>
  </thead>
  <tbody>
    <?php
      if (!empty($view->result)):
        $class = 'odd';
        $vm_nid = $view->args[0];
        $disk_info = famc_analytics_vm_disk_info($vm_nid);
        
        foreach ($view->result as $row):
            $path = !empty($row->field_field_path[0]['raw']['value']) ? $row->field_field_path[0]['raw']['value'] : '';
            //$disk_number = !empty($row->field_field_disk_index[0]['raw']['value']) ? $row->field_field_disk_index[0]['raw']['value'] : '';
    ?>
    <tr>
      <td class="<?php print $class; ?>">
        <?php print 'Disk: ' .$row->field_field_disk_index[0]['raw']['value']; ?>
      </td>
      <td class="<?php print $class; ?>">
        <span class="vdisk-path">
          <?php print trim($path); ?>
        </span>
        <span class="vdisk-wrench">
          <?php $wrench_image = '<img src = " ' . base_path() . drupal_get_path('module', 'mercury_utilities') . '/images/wrench.png" class = "wrench vdisk"/>';
            $str = mercury_utilities_vdisk_wrench_menu($row->nid);
            print $wrench_image;
            print $str
            //print_r($disk_info[$row->nid]);
          ?>
        </span>  
      </td>
      <td class="<?php print $class; ?>">
        <?php print trim($disk_info[$row->nid]['admin_state']); ?>
      </td>
      <td class="<?php print $class; ?>">
        <?php print trim($disk_info[$row->nid]['op_state']); ?>
      </td>
      <td class="<?php print $class; ?>">
        <?php
          if (is_numeric($disk_info[$row->nid]['hit_rate'])):
            print number_format($disk_info[$row->nid]['hit_rate'], 2);
          else:
            print $disk_info[$row->nid]['hit_rate'];
          endif;
        ?>
      </td>
      <td class="<?php print $class; ?>">
        <?php
          if (is_numeric($disk_info[$row->nid]['read_latency']) && is_numeric($disk_info[$row->nid]['write_latency'])):
            print trim(number_format($disk_info[$row->nid]['read_latency'], 2)) . ' / ' . trim(number_format($disk_info[$row->nid]['write_latency'], 2));
          else:
            print t('N/A');
          endif;
        ?>
      </td>
      <td class="<?php print $class; ?>">
        <span class="mercury-button">
          <?php print ctools_popups_vdiskinfo_link(t('Info'), $row->nid, 'Info', ''); ?>
        </span>
      </td>
    </tr>
    <?php
          $class = ($class == 'odd' ? 'even' : 'odd');
        endforeach;
    ?>
    <?php
      endif;
    ?>
  </tbody>
</table>
