<?php
/**
 *  Flash Accel Management Console (FMC)
 *  Copyright (C) 2013, NetApp, Inc.
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License along
 *  with this program; if not, write to the Free Software Foundation, Inc.,
 *  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 *
 *  Javascript
 *
 *    Farbtastic - Copyright (c) 2010 Matt Farina
 *
 *    jQuery - Copyright (c) 2010 John Resig
 * 
 *    jQuery BBQ - Copyright (c) 2010 "Cowboy" Ben Alman
 *  
 *    jQuery Cookie - Copyright (c) 2006 Klaus Hartl
 *  
 *    jQuery Form - Copyright (c) 2010 Mike Alsup
 *  
 *    jQuery Once - Copyright (c) 2009 Konstantin K\ufffdfer
 *
 *    jQuery UI - Copyright (c) 2010 by the original authors
 *      (http://jqueryui.com/about)
 *
 *    Sizzle.js - Copyright (c) 2010 The Dojo Foundation (http://sizzlejs.com/)
 *
 *  PHP
 *
 *    ArchiveTar - Copyright (c) 1997 - 2008 Vincent Blavet
 */
?>

 <table class="metrics">
  <thead>
    <tr>
      <th>
          <span>
        <?php print t('VM Name'); ?>
          </span>
      </th>
      <th>
          <span>
        <?php print t('Cache State'); ?>
          </span>
      </th>
      <th>
          <span>
        <?php print t('Operational Status'); ?>
          </span>
      </th>
      <th>
          <span>
        <?php print t('Cache'); ?>
          </span>
      </th>
      <th>
          <span>
        <?php print t('Hit Rate %'); ?>
          </span>
      </th>
      <th>
          <span>
        <?php print t('Read / Write Latency (ms)'); ?>
          </span>
      </th>
      <th>
        
      </th>
    </tr>
  </thead>
  <tbody>
    <?php
      if (!empty($view->result)):
        $class = 'odd';
        $host_nid = arg();
        
        foreach ($view->result as $row):
          $disk_info = famc_analytics_get_current_vm_metrics($row->nid);
        
    ?>
    <tr>
      <td class="<?php print $class; ?>">
       <span class="vm-node-title">
        <?php print trim($row->node_title); ?>
       </span>
       <span class="vm-wrench">
        <?php
          $wrench_image = '<img src = " ' . base_path() . drupal_get_path('module', 'mercury_utilities') . '/images/wrench.png" class = "wrench vm"/>';
          $str = mercury_utilities_vm_wrench_menu($row->nid);
          print $wrench_image;
          print $str;
        ?>
      </td>
      <td class="<?php print $class; ?>">
        <?php 
        if(isset($row->field_field_fa_administration_state[0]['raw']['value'])) {
            if($row->field_field_fa_administration_state[0]['raw']['value'] == "ADMIN_DISABLED") {
                print 'Disabled';
            }
            if($row->field_field_fa_administration_state[0]['raw']['value'] == "ADMIN_ENABLED") {
                print 'Enabled';
            }
        }
        ?>
      </td>
      <td class="<?php print $class; ?>">
       <?php 
        if(isset($row->field_field_fa_operational_state[0]['raw']['value'])) {
          print famc_analytics_string_overrides($row->field_field_fa_operational_state[0]['raw']['value']);
        }
        ?>
      </td>
      <td class="<?php print $class; ?>">
        <?php 
        if(isset($row->field_field_fa_cache_size[0]['raw']['value'])) {
            //print trim($row->field_field_fa_cache_size[0]['raw']['value']);
            print number_format($row->field_field_fa_cache_size[0]['raw']['value'] * $row->field_field_fa_sector_size[0]['raw']['value'] / 1073741824, 2) . ' GB';
        }
        ?>
      </td>
      <td class="<?php print $class; ?>">
        <?php 
        if(isset($disk_info['hit_rate_pc'])) {
          print trim($disk_info['hit_rate_pc']); 
        }
        else {
          print t('N/A');
        }
        ?>
      </td>
      <td class="<?php print $class; ?>">
        <?php 
        if(isset($disk_info['read_latency']) && isset($disk_info['write_latency'])) {
          print trim(number_format($disk_info['read_latency'], 2)) . ' / ' . trim(number_format($disk_info['write_latency'], 2)); 
        }
        else {
          print t('N/A');
        }
        ?>
      </td>
      <td class="<?php print $class; ?>">
        <span class="mercury-button">
          <?php print ctools_popups_vm_cache_info_link(t('Info'), $row->nid, 'Info', ''); ?>
        </span>
      </td>
    </tr>
    <?php
          $class = ($class == 'odd' ? 'even' : 'odd');
        endforeach;
    ?>
    <?php
      endif;
    ?>
  </tbody>
</table>
